install-sgx-psw.bin.tmpl 3.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126
  1. #!/usr/bin/env bash
  2. #
  3. # Copyright (C) 2011-2017 Intel Corporation. All rights reserved.
  4. #
  5. # Redistribution and use in source and binary forms, with or without
  6. # modification, are permitted provided that the following conditions
  7. # are met:
  8. #
  9. # * Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # * Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in
  13. # the documentation and/or other materials provided with the
  14. # distribution.
  15. # * Neither the name of Intel Corporation nor the names of its
  16. # contributors may be used to endorse or promote products derived
  17. # from this software without specific prior written permission.
  18. #
  19. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  20. # "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  21. # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  22. # A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  23. # OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  24. # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  25. # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  26. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  27. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  28. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  29. # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  30. #
  31. #
  32. grep intel_sgx /lib/modules/$(uname -r)/modules.builtin &> /dev/null
  33. if [[ $? != "0" ]]; then
  34. modinfo isgx &> /dev/null
  35. if [[ $? != "0" ]]; then
  36. lsmod | grep isgx &> /dev/null
  37. if [[ $? = "0" ]]; then
  38. echo "Warning: You did not follow the document to install the driver package"
  39. echo
  40. else
  41. echo "Please install the driver package before the PSW package"
  42. exit 4
  43. fi
  44. fi
  45. fi
  46. set -e
  47. PKG_NAME="Intel SGX PSW Package"
  48. if test $(id -u) -ne 0; then
  49. echo "Root privilege is required to install $PKG_NAME."
  50. exit 4
  51. fi
  52. PKG_ARCH=@arch@
  53. ARCH=$(uname -m)
  54. if [ $ARCH == "i386" ] || [ $ARCH == "i586" ] || [ $ARCH == "i686" ]; then
  55. ARCH=x86
  56. fi
  57. if [[ $ARCH != $PKG_ARCH ]]; then
  58. echo "$PKG_ARCH $PKG_NAME can not be installed on $ARCH platform."
  59. exit 4
  60. fi
  61. INSTALL_PATH=/opt/intel/sgxpsw
  62. if [ -d "$INSTALL_PATH" ]; then
  63. echo "$PKG_NAME already exists in $INSTALL_PATH, please uninstall it first!"
  64. exit 4
  65. fi
  66. PATH=/usr/bin:/bin
  67. umask 022
  68. PSWPKG=`mktemp -t sgx-psw-pkg.XXXXXX`
  69. PSW_TEMP_FOLDER=`mktemp -d sgx-psw-XXXXXX -p /tmp`
  70. trap "rm -fr $PSWPKG $PSW_TEMP_FOLDER= 2>/dev/null; exit 3" HUP INT QUIT TERM
  71. # The number of lines in this script (plus 1). Using this number to
  72. # calculate the start address of the payload.
  73. NR_SCRIPT_LINES=@linenum@
  74. # Run /usr/bin/md5sum on the binary payload to get the MD5 check sum.
  75. CHKSUM=@md5sum@
  76. # Get the install payload from this shell script.
  77. echo -n "Unpacking $PKG_NAME ..."
  78. tail -n +$NR_SCRIPT_LINES "$0" > $PSWPKG
  79. echo " done."
  80. echo -n "Verifying the integrity of the install package ..."
  81. if test $(md5sum $PSWPKG | awk '{print $1}') != $CHKSUM; then
  82. echo " The install package appears to be corrupted."
  83. exit 1
  84. fi
  85. echo " done."
  86. echo -n "Installing $PKG_NAME ..."
  87. tar zxf $PSWPKG -C $PSW_TEMP_FOLDER >/dev/null 2>&1
  88. retcode=$? # Save the return code
  89. # Clean-up the temporary tarball.
  90. rm -f $PSWPKG 2>/dev/null
  91. if test $retcode -ne 0; then
  92. echo " failed."
  93. exit 2
  94. fi
  95. echo " done."
  96. pushd $PSW_TEMP_FOLDER
  97. source scripts/installConfig
  98. make install
  99. popd
  100. ${SGX_PACKAGES_PATH}/${PSW_PKG_NAME}/scripts/install.sh
  101. rm -fr ${PSW_TEMP_FOLDER}
  102. exit 0